blob: 17fa901418ae6a491ba61f3814a1143e2a62bfde [file] [log] [blame]
Jamey Sharp153f0112011-05-05 12:03:47 -07001#!/bin/sh
Linus Torvalds1da177e2005-04-16 15:20:36 -07002# Copyright (C) Martin Schlemmer <azarah@nosferatu.za.org>
Oleg Verychf6112ec2007-02-06 02:18:20 +01003# Copyright (C) 2006 Sam Ravnborg <sam@ravnborg.org>
Sam Ravnborgd39a206b2006-04-11 13:24:32 +02004#
Linus Torvalds1da177e2005-04-16 15:20:36 -07005# Released under the terms of the GNU GPL
6#
Sam Ravnborgd39a206b2006-04-11 13:24:32 +02007# Generate a cpio packed initramfs. It uses gen_init_cpio to generate
Alain Knaffa26ee602009-01-07 00:10:27 -08008# the cpio archive, and then compresses it.
Sam Ravnborgd39a206b2006-04-11 13:24:32 +02009# The script may also be used to generate the inputfile used for gen_init_cpio
10# This script assumes that gen_init_cpio is located in usr/ directory
11
12# error out on errors
13set -e
14
15usage() {
16cat << EOF
17Usage:
18$0 [-o <file>] [-u <uid>] [-g <gid>] {-d | <cpio_source>} ...
Alain Knaffa26ee602009-01-07 00:10:27 -080019 -o <file> Create compressed initramfs file named <file> using
20 gen_init_cpio and compressor depending on the extension
Sam Ravnborgd39a206b2006-04-11 13:24:32 +020021 -u <uid> User ID to map to user ID 0 (root).
Mike Frysinger4c6f2eb2007-05-10 22:44:28 -070022 <uid> is only meaningful if <cpio_source> is a
23 directory. "squash" forces all files to uid 0.
Sam Ravnborgd39a206b2006-04-11 13:24:32 +020024 -g <gid> Group ID to map to group ID 0 (root).
Mike Frysinger4c6f2eb2007-05-10 22:44:28 -070025 <gid> is only meaningful if <cpio_source> is a
26 directory. "squash" forces all files to gid 0.
Sam Ravnborgd39a206b2006-04-11 13:24:32 +020027 <cpio_source> File list or directory for cpio archive.
Oleg Verychf6112ec2007-02-06 02:18:20 +010028 If <cpio_source> is a .cpio file it will be used
Sam Ravnborgd39a206b2006-04-11 13:24:32 +020029 as direct input to initramfs.
30 -d Output the default cpio list.
31
32All options except -o and -l may be repeated and are interpreted
33sequentially and immediately. -u and -g states are preserved across
34<cpio_source> options so an explicit "-u 0 -g 0" is required
35to reset the root/group mapping.
36EOF
37}
38
Oleg Verychf6112ec2007-02-06 02:18:20 +010039# awk style field access
40# $1 - field number; rest is argument string
41field() {
42 shift $1 ; echo $1
43}
44
Sam Ravnborgd39a206b2006-04-11 13:24:32 +020045list_default_initramfs() {
46 # echo usr/kinit/kinit
47 :
48}
Linus Torvalds1da177e2005-04-16 15:20:36 -070049
50default_initramfs() {
Sam Ravnborgd39a206b2006-04-11 13:24:32 +020051 cat <<-EOF >> ${output}
Linus Torvalds1da177e2005-04-16 15:20:36 -070052 # This is a very simple, default initramfs
53
54 dir /dev 0755 0 0
55 nod /dev/console 0600 0 0 c 5 1
56 dir /root 0700 0 0
Sam Ravnborgd39a206b2006-04-11 13:24:32 +020057 # file /kinit usr/kinit/kinit 0755 0 0
58 # slink /init kinit 0755 0 0
Linus Torvalds1da177e2005-04-16 15:20:36 -070059 EOF
60}
61
62filetype() {
63 local argv1="$1"
64
65 # symlink test must come before file test
66 if [ -L "${argv1}" ]; then
67 echo "slink"
68 elif [ -f "${argv1}" ]; then
69 echo "file"
70 elif [ -d "${argv1}" ]; then
71 echo "dir"
72 elif [ -b "${argv1}" -o -c "${argv1}" ]; then
73 echo "nod"
74 elif [ -p "${argv1}" ]; then
75 echo "pipe"
76 elif [ -S "${argv1}" ]; then
77 echo "sock"
78 else
79 echo "invalid"
80 fi
81 return 0
82}
83
Sam Ravnborgd39a206b2006-04-11 13:24:32 +020084list_print_mtime() {
85 :
Linus Torvalds1da177e2005-04-16 15:20:36 -070086}
87
Sam Ravnborgd39a206b2006-04-11 13:24:32 +020088print_mtime() {
89 local my_mtime="0"
90
91 if [ -e "$1" ]; then
92 my_mtime=$(find "$1" -printf "%T@\n" | sort -r | head -n 1)
93 fi
94
95 echo "# Last modified: ${my_mtime}" >> ${output}
96 echo "" >> ${output}
97}
98
99list_parse() {
Maxime Bizon9e5ec862009-02-09 18:49:52 +0100100 [ ! -L "$1" ] && echo "$1 \\" || :
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200101}
102
103# for each file print a line in following format
104# <filetype> <name> <path to file> <octal mode> <uid> <gid>
105# for links, devices etc the format differs. See gen_init_cpio for details
Linus Torvalds1da177e2005-04-16 15:20:36 -0700106parse() {
107 local location="$1"
Jamey Sharp153f0112011-05-05 12:03:47 -0700108 local name="/${location#${srcdir}}"
Linus Torvalds1da177e2005-04-16 15:20:36 -0700109 # change '//' into '/'
Jamey Sharp153f0112011-05-05 12:03:47 -0700110 name=$(echo "$name" | sed -e 's://*:/:g')
Linus Torvalds1da177e2005-04-16 15:20:36 -0700111 local mode="$2"
112 local uid="$3"
113 local gid="$4"
114 local ftype=$(filetype "${location}")
115 # remap uid/gid to 0 if necessary
Mike Frysinger4c6f2eb2007-05-10 22:44:28 -0700116 [ "$root_uid" = "squash" ] && uid=0 || [ "$uid" -eq "$root_uid" ] && uid=0
117 [ "$root_gid" = "squash" ] && gid=0 || [ "$gid" -eq "$root_gid" ] && gid=0
Linus Torvalds1da177e2005-04-16 15:20:36 -0700118 local str="${mode} ${uid} ${gid}"
119
Jamey Sharp153f0112011-05-05 12:03:47 -0700120 [ "${ftype}" = "invalid" ] && return 0
121 [ "${location}" = "${srcdir}" ] && return 0
Linus Torvalds1da177e2005-04-16 15:20:36 -0700122
123 case "${ftype}" in
124 "file")
125 str="${ftype} ${name} ${location} ${str}"
126 ;;
127 "nod")
Oleg Verychf6112ec2007-02-06 02:18:20 +0100128 local dev=`LC_ALL=C ls -l "${location}"`
129 local maj=`field 5 ${dev}`
130 local min=`field 6 ${dev}`
131 maj=${maj%,}
Linus Torvalds1da177e2005-04-16 15:20:36 -0700132
Oleg Verychf6112ec2007-02-06 02:18:20 +0100133 [ -b "${location}" ] && dev="b" || dev="c"
134
135 str="${ftype} ${name} ${str} ${dev} ${maj} ${min}"
Linus Torvalds1da177e2005-04-16 15:20:36 -0700136 ;;
137 "slink")
Felix Fietkaub5a5e4c2008-04-02 14:50:05 +0200138 local target=`readlink "${location}"`
Linus Torvalds1da177e2005-04-16 15:20:36 -0700139 str="${ftype} ${name} ${target} ${str}"
140 ;;
141 *)
142 str="${ftype} ${name} ${str}"
143 ;;
144 esac
145
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200146 echo "${str}" >> ${output}
Linus Torvalds1da177e2005-04-16 15:20:36 -0700147
148 return 0
149}
150
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200151unknown_option() {
152 printf "ERROR: unknown option \"$arg\"\n" >&2
153 printf "If the filename validly begins with '-', " >&2
154 printf "then it must be prefixed\n" >&2
155 printf "by './' so that it won't be interpreted as an option." >&2
156 printf "\n" >&2
157 usage >&2
158 exit 1
Linus Torvalds1da177e2005-04-16 15:20:36 -0700159}
160
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200161list_header() {
Thomas Choua26d79c2006-11-25 11:09:18 -0800162 :
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200163}
Linus Torvalds1da177e2005-04-16 15:20:36 -0700164
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200165header() {
166 printf "\n#####################\n# $1\n" >> ${output}
167}
Linus Torvalds1da177e2005-04-16 15:20:36 -0700168
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200169# process one directory (incl sub-directories)
170dir_filelist() {
171 ${dep_list}header "$1"
172
173 srcdir=$(echo "$1" | sed -e 's://*:/:g')
Michael Ellermaneda890a2007-04-30 15:34:15 +1000174 dirlist=$(find "${srcdir}" -printf "%p %m %U %G\n")
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200175
176 # If $dirlist is only one line, then the directory is empty
177 if [ "$(echo "${dirlist}" | wc -l)" -gt 1 ]; then
178 ${dep_list}print_mtime "$1"
179
180 echo "${dirlist}" | \
181 while read x; do
182 ${dep_list}parse ${x}
183 done
184 fi
185}
186
187# if only one file is specified and it is .cpio file then use it direct as fs
188# if a directory is specified then add all files in given direcotry to fs
189# if a regular file is specified assume it is in gen_initramfs format
190input_file() {
191 source="$1"
192 if [ -f "$1" ]; then
193 ${dep_list}header "$1"
Alex Landauc299ec22007-04-26 00:17:29 -0700194 is_cpio="$(echo "$1" | sed 's/^.*\.cpio\(\..*\)\?/cpio/')"
Jamey Sharp153f0112011-05-05 12:03:47 -0700195 if [ $2 -eq 0 -a ${is_cpio} = "cpio" ]; then
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200196 cpio_file=$1
Alex Landauc299ec22007-04-26 00:17:29 -0700197 echo "$1" | grep -q '^.*\.cpio\..*' && is_cpio_compressed="compressed"
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200198 [ ! -z ${dep_list} ] && echo "$1"
199 return 0
Linus Torvalds1da177e2005-04-16 15:20:36 -0700200 fi
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200201 if [ -z ${dep_list} ]; then
202 print_mtime "$1" >> ${output}
203 cat "$1" >> ${output}
204 else
Jason Gunthorpeb8341932010-03-22 16:49:32 -0600205 echo "$1 \\"
Sam Ravnborg46ed9812006-04-30 23:56:33 +0200206 cat "$1" | while read type dir file perm ; do
Jamey Sharp153f0112011-05-05 12:03:47 -0700207 if [ "$type" = "file" ]; then
Sam Ravnborg46ed9812006-04-30 23:56:33 +0200208 echo "$file \\";
209 fi
210 done
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200211 fi
212 elif [ -d "$1" ]; then
213 dir_filelist "$1"
Linus Torvalds1da177e2005-04-16 15:20:36 -0700214 else
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200215 echo " ${prog}: Cannot open '$1'" >&2
Linus Torvalds1da177e2005-04-16 15:20:36 -0700216 exit 1
217 fi
218}
219
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200220prog=$0
Linus Torvalds1da177e2005-04-16 15:20:36 -0700221root_uid=0
222root_gid=0
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200223dep_list=
224cpio_file=
225cpio_list=
226output="/dev/stdout"
227output_file=""
Alex Landauc299ec22007-04-26 00:17:29 -0700228is_cpio_compressed=
Michal Marek6ae9ecb2011-03-31 15:47:55 +0200229compr="gzip -n -9 -f"
Linus Torvalds1da177e2005-04-16 15:20:36 -0700230
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200231arg="$1"
232case "$arg" in
233 "-l") # files included in initramfs - used by kbuild
234 dep_list="list_"
Jason Gunthorpeb8341932010-03-22 16:49:32 -0600235 echo "deps_initramfs := $0 \\"
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200236 shift
237 ;;
Alain Knaffa26ee602009-01-07 00:10:27 -0800238 "-o") # generate compressed cpio image named $1
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200239 shift
240 output_file="$1"
241 cpio_list="$(mktemp ${TMPDIR:-/tmp}/cpiolist.XXXXXX)"
242 output=${cpio_list}
P J P9ba4bcb2013-11-12 15:10:22 -0800243 echo "$output_file" | grep -q "\.gz$" \
244 && [ -x "`which gzip 2> /dev/null`" ] \
245 && compr="gzip -n -9 -f"
246 echo "$output_file" | grep -q "\.bz2$" \
247 && [ -x "`which bzip2 2> /dev/null`" ] \
248 && compr="bzip2 -9 -f"
249 echo "$output_file" | grep -q "\.lzma$" \
250 && [ -x "`which lzma 2> /dev/null`" ] \
251 && compr="lzma -9 -f"
252 echo "$output_file" | grep -q "\.xz$" \
253 && [ -x "`which xz 2> /dev/null`" ] \
254 && compr="xz --check=crc32 --lzma2=dict=1MiB"
255 echo "$output_file" | grep -q "\.lzo$" \
256 && [ -x "`which lzop 2> /dev/null`" ] \
257 && compr="lzop -9 -f"
258 echo "$output_file" | grep -q "\.lz4$" \
259 && [ -x "`which lz4 2> /dev/null`" ] \
Daniel M. Weeks5ec384d2014-03-03 15:38:28 -0800260 && compr="lz4 -l -9 -f"
Alain Knaffa26ee602009-01-07 00:10:27 -0800261 echo "$output_file" | grep -q "\.cpio$" && compr="cat"
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200262 shift
263 ;;
264esac
Linus Torvalds1da177e2005-04-16 15:20:36 -0700265while [ $# -gt 0 ]; do
266 arg="$1"
267 shift
268 case "$arg" in
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200269 "-u") # map $1 to uid=0 (root)
Linus Torvalds1da177e2005-04-16 15:20:36 -0700270 root_uid="$1"
271 shift
272 ;;
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200273 "-g") # map $1 to gid=0 (root)
Linus Torvalds1da177e2005-04-16 15:20:36 -0700274 root_gid="$1"
275 shift
276 ;;
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200277 "-d") # display default initramfs list
Linus Torvalds1da177e2005-04-16 15:20:36 -0700278 default_list="$arg"
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200279 ${dep_list}default_initramfs
Linus Torvalds1da177e2005-04-16 15:20:36 -0700280 ;;
281 "-h")
282 usage
283 exit 0
284 ;;
285 *)
286 case "$arg" in
287 "-"*)
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200288 unknown_option
Linus Torvalds1da177e2005-04-16 15:20:36 -0700289 ;;
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200290 *) # input file/dir - process it
291 input_file "$arg" "$#"
Linus Torvalds1da177e2005-04-16 15:20:36 -0700292 ;;
293 esac
294 ;;
295 esac
296done
297
Alain Knaffa26ee602009-01-07 00:10:27 -0800298# If output_file is set we will generate cpio archive and compress it
Lucas De Marchi25985ed2011-03-30 22:57:33 -0300299# we are careful to delete tmp files
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200300if [ ! -z ${output_file} ]; then
301 if [ -z ${cpio_file} ]; then
Michal Mareka8b80172011-03-31 23:16:42 +0200302 timestamp=
303 if test -n "$KBUILD_BUILD_TIMESTAMP"; then
304 timestamp="$(date -d"$KBUILD_BUILD_TIMESTAMP" +%s || :)"
305 if test -n "$timestamp"; then
306 timestamp="-t $timestamp"
307 fi
308 fi
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200309 cpio_tfile="$(mktemp ${TMPDIR:-/tmp}/cpiofile.XXXXXX)"
Michal Mareka8b80172011-03-31 23:16:42 +0200310 usr/gen_init_cpio $timestamp ${cpio_list} > ${cpio_tfile}
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200311 else
312 cpio_tfile=${cpio_file}
313 fi
314 rm ${cpio_list}
Alex Landauc299ec22007-04-26 00:17:29 -0700315 if [ "${is_cpio_compressed}" = "compressed" ]; then
316 cat ${cpio_tfile} > ${output_file}
317 else
Alain Knaffab59d3b2009-02-19 13:39:21 -0800318 (cat ${cpio_tfile} | ${compr} - > ${output_file}) \
319 || (rm -f ${output_file} ; false)
Alex Landauc299ec22007-04-26 00:17:29 -0700320 fi
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200321 [ -z ${cpio_file} ] && rm ${cpio_tfile}
322fi
Linus Torvalds1da177e2005-04-16 15:20:36 -0700323exit 0